﻿<?PHP
	## Configuration #######################################################################

	$root = dirname(dirname(__DIR__));
	define( 'AUTO_DOMAIN_ROOT', $root.'/domains' );
	define( 'AUTO_DOMAIN_OPENSERV_CONF', $root.'/userdata/profiles/Default_domains.txt' );

	## Directly script #####################################################################

	class autoDomain
	{
		/**
		 * Основная директория домена
		 */
		const DEFHOME = 'www';
		/**
		 * Стандартный файл настроек доменов openserver
		 */
		const OPENSERV_CONF = AUTO_DOMAIN_OPENSERV_CONF;
		/**
		 * Директория сканирования
		 * 
		 * @var string
		 */
		protected $_root_dir = AUTO_DOMAIN_ROOT;
		/**
		 * Ассоциативный массив основных доменов и их поддоменов
		 * 
		 * @var array
		 */
		protected $_data_tree = null;
		/**
		 * Массив всех доменов
		 * 
		 * @var array
		 */
		protected $_data_list = null;
		/**
		 * Инициализация класса
		 * 
		 * @param  void
		 * @return void
		 * @access public
		 */
		public function __construct()
		{
			$this->_makeDomainData();
		}
		/**
		 * Сканирует директории и подготавливает список доменов и их соотношение
		 * 
		 * @param  void
		 * @return int
		 * @access protected
		 */
		protected function _makeDomainData()
		{
			$root = $this->_root_dir;
			$home = $this::DEFHOME;
			//
			$list1 = glob( $root.'/*', GLOB_ONLYDIR );
			//
			$domain_list = array();
			$domain_tree = array();
			foreach( $list1 as $one )
			{
				$name = basename($one);
				$domain_tree[$name] = array();
				//
				// individual map
				if( file_exists($one.'/.noautodomain') ){
					if( filesize($one.'/.noautodomain') ){
						$ini = @parse_ini_file($one.'/.noautodomain');
						if( !$ini )continue;
						$domain_tree[$name] = array();
						$folder = str_replace( $root, null, $one );
						foreach( $ini as $key => $subfolder ){
							$domain_tree[$name][$key] = $folder.'/'.$subfolder;
							if( $key == $home )$key = null;
							else $subone.='.';
							$domain_list[$key.$name] = $folder.'/'.$subfolder;
						}
					}
					continue;
				}
				// is root domain only
				if( !is_dir($one.'/'.$home) ){
					$folder = str_replace( $root, null, $one );
					$domain_tree[$name][$home] = $folder;
					$domain_list[$name] = $folder;
					continue;
				}
				//
				// standart denwer map
				$list2 = glob( $one.'/*', GLOB_ONLYDIR );
				foreach( $list2 as $subone ){
					$folder = str_replace( $root, null, $subone );
					$subone = basename($subone);
					$domain_tree[$name][$subone] = $folder;
					if( $subone == $home )$subone = null;
					else $subone.='.';
					$domain_list[$subone.$name] = $folder;
				}
			}
			$this->_data_tree = $domain_tree;
			$this->_data_list = $domain_list;
			//
			return count($domain_list);
		}
		/**
		 * Возвращает массив доменов
		 * 
		 * @param  void
		 * @return array
		 * @access private
		 */
		public function getDomainList()
		{
			return $this->_data_list;
		}
		/**
		 * Возвращает ассоциативный массив основных доменов и их поддоменов
		 * 
		 * @param  void
		 * @return array
		 * @access private
		 */
		public function getDomainTree()
		{
			return $this->_data_tree;
		}
		/**
		 * Записывает стандартный файл настроек доменов openserver
		 * 
		 * @param  void
		 * @return string  json
		 * @access private
		 */
		public function writeDomainList()
		{
			if( !file_exists($this::OPENSERV_CONF) )return false;
			//
			$list = $this->getDomainList();
			//
			$data = null;
			foreach( $list as $domain =>$folder ){
				$data .= $domain.';'.str_replace( '\\', '/', $folder )."\n";
			}
			$size = file_put_contents( $this::OPENSERV_CONF, $data );
			//
			return '{"domain":'.count($list).',"write":'.$size.'}';
		}
	}

	## End of file #########################################################################

// EOF